# Generated by Django 3.2.9 on 2022-04-05 19:36

from django.db import models, migrations

def apply_migration(apps, schema_editor):
    Group = apps.get_model('auth', 'Group')
    Group.objects.bulk_create([
        Group(name='professor'),
        Group(name='student')
    ])

def revert_migration(apps, schema_editor):
    Group = apps.get_model('auth', 'Group')
    Group.objects.filter(
        name__in=[
            'professor',
            'student'
        ]
    ).delete()

class Migration(migrations.Migration):

    dependencies = [
        ('pasapp', '0007_auto_20211215_0114'),
    ]

    operations = [
        migrations.RunPython(apply_migration, revert_migration)
    ]
